Unit ec00r_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, FTF1C_p;

procedure ec00r(N :Integer; DT :Real; var A :Array of Real;
                var Y :Array of Real; ALP :Real; P :Real; L :Integer;
                var H :Array of Real; var X :Array of Real;
                var Z :Array of Real);

implementation

procedure ec00r(N :Integer; DT :Real; var A :Array of Real;
                var Y :Array of Real; ALP :Real; P :Real; L :Integer;
                var H :Array of Real; var X :Array of Real;
                var Z :Array of Real);
var
I,N1,N2,N3,N4,N5 :Integer;
Q,B,C,DW,P1,S1,S2,S3,R1,R2,R3,R4,R5,R6,R7,R8,W,R :Real;
const
SYS003 :Real = 6.2831853071795864769252867665590;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11;
begin
N1 := Trunc( N/2 );
case L of
 1: goto _1;
 2: goto _7;
 3: goto _7;
 4: goto _4;
end;
_1:
for I:=1 to N do
 begin
_2:
  X[I-1] := 0.0;
 end;
Q := 1.0;
FTF1C(A,X,N,1,1,Q);
for I:=2 to N1 do
 begin
  N2 := N1+I;
_3:
  A[N2-1] := X[I-1];
 end;
_4:
for I:=1 to N do
 begin
_5:
  X[I-1] := 0.0;
 end;
Q := 1.0;
FTF1C(Y,X,N,1,1,Q);
for I:=2 to N1 do
 begin
  N2 := N1+I;
_6:
  Y[N2-1] := X[I-1];
 end;
goto _11;
_7:
B := 1.0/N;
C := 1.0/DT;
DW := SYS003*B*C;
P1 := 2*P;
Q := ALP*C*C;
S1 := 0.0;
S2 := 0.0;
S3 := 0.0;
for I:=2 to N1 do
 begin
  N2 := N1+I;
  R1 := A[I-1];
  R2 := A[N2-1];
  R3 := Y[I-1];
  R4 := Y[N2-1];
  R5 := R1*R1+R2*R2;
  W := DW*(I-1);
  R := Power(W,P1);
  R6 := 1.0/(R5+Q*R);
  R7 := ((R1*R3+R2*R4)*C)*R6;
  R8 := ((R1*R4-R2*R3)*C)*R6;
  X[I-1] := R7;
  X[N2-1] := R8;
  R3 := DT*(R1*R7-R2*R8)-R3;
  R4 := DT*(R1*R8+R2*R7)-R4;
  S1 := S1+R3*R3+R4*R4;
  R3 := (R*B)*(R7*R7+R8*R8);
  S2 := S2+R3;
  R4 := W*((ALP*R6)*R)*(ALP*R6)*R3;
_8:
  S3 := S3+R4;
 end;
R3 := 0.0;
if ( P = 0. ) 
 then R3 := 1.0;
X[0] := A[0]*Y[0]*C/(A[0]*A[0]+Q*R3);
R1 := DT*A[0]*X[0]-Y[0];
R := Power(DW*N1,P1);
N3 := Trunc( N/2+1 );
R6 := A[N3-1]*A[N3-1]+Q*R;
X[N3-1] := A[N3-1]*Y[N3-1]*C/R6;
R2 := DT*A[N3-1]*X[N3-1]-Y[N3-1];
S1 := (S1*2+R1*R1+R2*R2)*DT*B;
S2 := (S2*2+(R3*B)*X[0]*X[0]+(R*B)*X[N3-1]*X[N3-1])*DT;
H[0] := Sqrt(S1);
H[1] := Sqrt(S2);
H[2] := Sqrt(S1+ALP*S2);
R5 := ((ALP/R6)*R)*X[N3-1];
R4 := (DW/2.0*R5)*R5;
H[3] := Sqrt((S3*2+R4)*C)*C;
if ( L = 3 ) 
 then goto _11;
Z[0] := 0.0;
Z[N3-1] := 0.0;
N4 := N1+2;
N5 := N+2;
for I:=2 to N1 do
 begin
  N2 := N1+I;
  Z[I-1] := X[N2-1];
  N3 := N4-I;
  X[N2-1] := X[N3-1];
  N3 := N5-I;
_9:
  Z[N3-1] := -Z[I-1];
 end;
Q := -1.0;
FTF1C(X,Z,N,1,1,Q);
for I:=1 to N1 do
 begin
  R := X[I-1]*B;
  N2 := N1+I;
  X[I-1] := X[N2-1]*B;
_10:
  X[N2-1] := R;
 end;
_11:
end;

end.
